function [VI, I] = VI_metric(I,varargin)
%   Copyright (C) 2015 Javier Royuela del Val  <jroyval@lpi.tel.uva.es>
%                      Santiago Sanz Estébanez <ssanest@lpi.tel.uva.es>
%   Laboratorio de Procesado de Imagen, Universidad de Valladolid
%   www.lpi.tel.uva.es
%
%   This program is free software: you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation, either version 3 of the License, or
%   (at your option) any later version.
%
%   This program is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
%
%   You should have received a copy of the GNU General Public License
%   along with this program.  If not, see <http://www.gnu.org/licenses/>.



s = size(I);
L = length(s)-1;
N = s(end);

nvarin = length(varargin);
if nvarin==2
    Nroi = varargin{2};
    roi = varargin{1};
elseif nvarin==1
    roi = varargin{1};
    Nroi = sum(roi(:));
else
    roi = [];
    Nroi = [];
end


if ~isempty(roi)
    % Get pixels in the mask and reshape into column vector
    I = reshape(I(repmat(roi==1,[ones(1,L), N])),[Nroi,N]);
else
    I = reshape(I,[prod(s(1:L)), N]);
end

% Variance along temporal dimension in the roi
VI = gather(sum(var(I,1,2)));

end
