function [ detJac ] = bsplines_detJac(x,ts,T_ite)
%bsplines_detJac returns de Jacobian (determinant of the Jacobian matrix of
%the B-splines deformation given by the struct ts and the control points
%values in T_ite matrix.
%
%   Copyright (C) 2015 Javier Royuela del Val  <jroyval@lpi.tel.uva.es>
%                      Santiago Sanz Estébanez <ssanest@lpi.tel.uva.es>
%   Laboratorio de Procesado de Imagen, Universidad de Valladolid
%   www.lpi.tel.uva.es
%
%   This program is free software: you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation, either version 3 of the License, or
%   (at your option) any later version.
%
%   This program is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
%
%   You should have received a copy of the GNU General Public License
%   along with this program.  If not, see <http://www.gnu.org/licenses/>.


[dx1,dx2] = bspline_spatial_gradient(x,ts,T_ite,1);
detJac = (dx1(:,:,:,1)+1).*(dx2(:,:,:,2)+1) - dx1(:,:,:,2).*dx2(:,:,:,1); 

end

