function [ Tdif ] = evolucion( T,H,iter,Wn,pxTh )
    %   Copyright (C) 2015 Javier Royuela del Val  <jroyval@lpi.tel.uva.es>
%                      Santiago Sanz Estébanez <ssanest@lpi.tel.uva.es>
%   Laboratorio de Procesado de Imagen, Universidad de Valladolid
%   www.lpi.tel.uva.es
%
%   This program is free software: you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation, either version 3 of the License, or
%   (at your option) any later version.
%
%   This program is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
%
%   You should have received a copy of the GNU General Public License
%   along with this program.  If not, see <http://www.gnu.org/licenses/>.

%calculo las diferencias
%norma
D = ndims(T);
if D == 2 % Registrado rigido
    if size(T,1)==2
        Tdif=norm(T);
    elseif  size(T,1)==3  %traslacional
        %ponderacion de la norma (1./Wn)/((1/peso1n) +(1/peso2n) +(1/peso3n))
        Tdif= norm(1./(Wn*(sum(1./(Wn(:,1))))).*T);
    end
else % B-splines 2D or 3D
    %norma de todos los elementos en fila
    %Tdif=norm(T(:));
    % De javi: norm(T(:))=sqrt(sum(T(:).^2))
    %    no me convence demasiado
    % Mejor basado en la norma de cada desplazamiento en la roi
    Tdif = sqrt( sum( T.^2, D ) );
    % Numero de desplazamientos mayores que un umbral (en pixels)
    Tdif = sum( Tdif(:) > pxTh );
    % Los puntos en la caja pero no en la roi se desplazan 0 y no afectan.
end

end

