function IT = interpolar(x,xn,I,interpolacion,value)
%   Copyright (C) 2015 Javier Royuela del Val  <jroyval@lpi.tel.uva.es>
%                      Santiago Sanz Estébanez <ssanest@lpi.tel.uva.es>
%   Laboratorio de Procesado de Imagen, Universidad de Valladolid
%   www.lpi.tel.uva.es
%
%   This program is free software: you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation, either version 3 of the License, or
%   (at your option) any later version.
%
%   This program is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
%
%   You should have received a copy of the GNU General Public License
%   along with this program.  If not, see <http://www.gnu.org/licenses/>.

vec = @(x)x(:);
dataType = class(xn);
s  = size(x);
sn = size(xn);
L  = length(s)-1;
N  = size(xn,L+1);

if ~exist('value','var')
    value = 0;
end

% if (any(isnan(I(:))) || any(isnan(xn(:))))
%     warn('NaN in interpolar function');
% end

if L == 2
    
    IT = zeros(sn(1:end-1),dataType);
    
    parfor n = 1:N
        x_ = x;
        xn_ = xn(:,:,n,:);
        IT(:,:,n) = interp2(x_(:,:,1), x_(:,:,2), I(:,:,n), ...
                            xn_(:,:,1,1), xn_(:,:,1,2), ...
                            interpolacion, value);
    end
    
elseif L == 3
    
    IT = zeros(sn(1:4));
    
    x_ = vec(x(1,:,1,1));
    y_ = vec(x(:,1,1,2));
    z_ = vec(x(1,1,:,3));

    parfor n = 1:N
        xn_ = xn(:,:,:,n,:);

        %IT(:,:,:,n) = interp3_gpu(x_, y_, z_, I(:,:,:,n), ...
         ...                   xn_(:,:,:,1,1), xn_(:,:,:,1,2), xn_(:,:,:,1,3));
        IT(:,:,:,n) = interp3(x_, y_, z_, I(:,:,:,n), ...
                          xn_(:,:,:,1,1), xn_(:,:,:,1,2), xn_(:,:,:,1,3));
    end
    
else
    error('err dim');
end

end

