% BS registration test
%   Copyright (C) 2015 Javier Royuela del Val  <jroyval@lpi.tel.uva.es>
%                      Santiago Sanz Estébanez <ssanest@lpi.tel.uva.es>
%   Laboratorio de Procesado de Imagen, Universidad de Valladolid
%   www.lpi.tel.uva.es
%
%   This program is free software: you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation, either version 3 of the License, or
%   (at your option) any later version.
%
%   This program is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
%
%   You should have received a copy of the GNU General Public License
%   along with this program.  If not, see <http://www.gnu.org/licenses/>.

clear

addpath ./bsplines;
addpath ~/Dropbox/Tesis/workspace/matlab/scripts/;

ruta = '~/Dropbox/Tesis/workspace/data/00/DICOM';

[im] = loaddatos(ruta,'im',9,30);
% Seleccion corte 4
I = im2double(im(:,:,:,4));
clear im

%I=I(1:end-1,1:end-1,:);
%I = I./max(I(:));

tam = size(I);
N=tam(3);
[x(:,:,1), x(:,:,2)] = meshgrid(1:tam(2),1:tam(1));%malla original de imagen xo

Dp=[2 2];
E=3;
radio=64;
centro=[135, 120];
[X, areaX, caja]=circROI_bs(I,centro,radio);

% X = ones([size(I,1),size(I,2)]);
% rp = ceil((E+1)*Dp(:));
% X([1:rp(2) end-rp(2)+1:end],:)=0;
% X(:,[1:rp(1) end-rp(1)+1:end])=0;
% areaX = sum(X(:));
% caja = [  rp(1)+1, size(I,2)-rp(1);
%           rp(2)+1, size(I,1)-rp(2)  ];


%variables bspline, devueltas en ts  

[ts, T]=bspline_init(x,caja,Dp,E,tam(3));

%Defino los parametros requeridos para el gradiente descendente
% nmax=50;
% et=0.01;%0.01 pixel para tener una convergencia plena.
% eh=0.005;%es un 0.5% del inicial
parametros.nmax = 60;
parametros.et = 0.001; % 0.1% of moving pixels.
parametros.eh = 0.005; % Relative variation of 0.5% inter iterations
% parametros.le = 100*[0.2 1 0.1 0.6];
parametros.le = 0.0000001*[.1 .4 1 1];
parametros.t0 = 5;
parametros.pxTh = 0.25;     % Displacement threshold
%parametros.interpolation = '*linear';
parametros.interpolation = '*linear';
parametros.reg_metric = @VI_metric;
parametros.reg_gradient = @VI_gradient;

W=1+T; %matriz de pesos mismo para cada desplazamiento en cada punto de cada imagen
Wn=W/areaX;%normalizacion

tic;
[ H{1}, tiempo{1}, T, IT, optout] = optimizadorcg_javi(x, ts, T, I, X, parametros, Wn);
toptim = toc;

for i = 1:length(H)
    plot(tiempo{i}(2:end),H{i},sprintf('%Dp=%d,%d,le=%f',Dp(1),Dp(2),parametros.le));
end


%transformacion final para eliminar efectos de bordes (toda la imagen)
% clearvars -except H tiempo I IT tam x Dp E areaX X datos parametros
% caja=[1 tam(2);1 tam(1)];
% ts=creabspline(x,caja,[30 30],1,tam(3));
% T=zeros(sum(ts.C(2,:))+1,sum(ts.C(1,:))+1,tam(3),ts.nt);
% Wn=(7+T)/areaX;
% parametros.nmax=1;
% [ ~, ~, ~, ITfinal] = optimizador( x,ts,T,IT,datos,X,parametros,Wn,caja );
%   
% pelicula(I,ITfinal)

%% pinta puntos de control en secuencia
% ITp = I;
% s=size(I);
% maxv = max(ITp(:));
% nn = round(bsxfun(@plus,permute(ts.pu,[1 2 4 3]),T));
% for t=1:s(3)
%     ny = nn(:,:,t,1);
%     nx = nn(:,:,t,2);
%     idx = sub2ind(s(1:2),nx(:),ny(:));
%     ITp(idx+s(1)*s(2)*(t-1)) = maxv;
% end
% 

s=size(I);
padeo = ceil([s(1) 2*s(2)]/8)*8-[s(1) 2*s(2)];
M = sec2movie(padarray([I IT],padeo,0,'pre'));
movie2avi(M,'reg_javi.avi');

%% pinta puntos de control en secuencia
% necesario interpolado
L = 2; %Factor interpolado.
s=size(I);
[xp(:,:,1) xp(:,:,2)] = meshgrid(1:1/L:s(2),1:1/L:s(1));
sp = [size(xp(:,:,1)) s(3)];
maxI = max(I(:));
maxIT= max(IT(:));
Iinterp = zeros(sp);
ITinterp = zeros(sp);
for t=1:size(I,3)
    Iinterp(:,:,t)  = interp2(x(:,:,1),x(:,:,2),I(:,:,t)/maxI,xp(:,:,1),xp(:,:,2));
    ITinterp(:,:,t) = interp2(x(:,:,1),x(:,:,2),IT(:,:,t)/maxIT,xp(:,:,1),xp(:,:,2));
end
ITinterp(isnan(ITinterp))=0;
[pu(:,:,1) pu(:,:,2)] = meshgrid(ts.v1,ts.v2);
Ip=Iinterp;
nn = bsxfun(@plus,permute(pu,[1 2 4 3]),T);
padeo = ceil([sp(1) 2*sp(2)]/8)*8-[sp(1) 2*sp(2)];

color = 1;
if color==1
    padeo    = [padeo 0];
    Ip       = cat(3,zeros([sp(1:2),2,sp(3)]),permute(Ip      ,[1 2 4 3]));
    ITinterp = cat(3,zeros([sp(1:2),2,sp(3)]),permute(ITinterp,[1 2 4 3]));
    hue = optout.Ex;
    %hue = 0.67-(1-(1-hue./max(hue(:))).^10)*0.67;
    hue = log10(hue+1e-3)+3;
    hue = mod(0.67-0.88*hue./max(hue(:)),1);
    
end

% for t=1:s(3)
%     ny = round(nn(:,:,t,1)*L);
%     nx = round(nn(:,:,t,2)*L);
%     ny(ny<1)=1; ny(ny>sp(1))  = sp(1);
%     nx(nx<1)=1; nx(nx>sp(2))  = sp(2);
%     idx = sub2ind(sp(1:2),nx(:),ny(:));
%     if color==1
%         Ip(idx+sp(1)*sp(2)*3*(t-1))=hue(:,:,t) ; % Hue (Energy)
%         Ip(idx+sp(1)*sp(2)*3*(t-1)+sp(1)*sp(2))=1.0; % Saturation
%         Ip(idx+sp(1)*sp(2)*3*(t-1)+2*sp(1)*sp(2))=1.0; % Value
%     else
%         Ip(idx+sp(1)*sp(2)*(t-1)) = 1.0;
%     end
% end

for t=1:s(3)
    ny = round(nn(:,:,t,1)*L);
    nx = round(nn(:,:,t,2)*L);
    ny(ny<1)=1; ny(ny>sp(1))  = sp(1);
    nx(nx<1)=1; nx(nx>sp(2))  = sp(2);
    idx = sub2ind(sp(1:2),nx(:),ny(:));
    huep = interp2(x(:,:,1),x(:,:,2),hue(:,:,t),xp(:,:,1),xp(:,:,2),'nearest');
    if color==1
        Ip(:,:,1,t) = huep; % Set hue to E
        Ip(:,:,2,t) = 1.0;  % Set saturation to one
        %Ip(idx+sp(1)*sp(2)*3*(t-1))=hue(:,:,t) ; % Hue (Energy)
        %Ip(idx+sp(1)*sp(2)*3*(t-1)+sp(1)*sp(2))=1.0; % Saturation
        % Set value of control points to one
        Ip(idx+sp(1)*sp(2)*3*(t-1)+2*sp(1)*sp(2))=1.0;
        
    else
        Ip(idx+sp(1)*sp(2)*(t-1)) = 1.0;
    end
end

if color==1
    M = rgbsec2movie(padarray([Ip ITinterp],padeo,0,'pre'),'HSV');
else
    M = sec2movie(padarray([Ip ITinterp],padeo,0,'pre'));
end
%movie(M,20);
movie2avi(M,'reg_points_javi.avi');

%% pinta evolucion puntos de control sobre seleccion de frames
fr = [1 15 24];
Niter = size(optout.T,5);
Iaux = repmat(Iinterp(:,:,fr),[1 1 1 Niter]);
[pu(:,:,1) pu(:,:,2)] = meshgrid(ts.v1,ts.v2);
for iter = 1:Niter
    nn = bsxfun(@plus,permute(pu,[1 2 4 3]),optout.T(:,:,:,:,iter));
    for t=1:length(fr)
        ny = round(nn(:,:,fr(t),1)*L);
        nx = round(nn(:,:,fr(t),2)*L);
        ny(ny<1)=1; ny(ny>sp(1))  = sp(1);
        nx(nx<1)=1; nx(nx>sp(2))  = sp(2);
        idx = sub2ind(sp(1:2),nx(:),ny(:));
        Iaux(idx+sp(1)*sp(2)*(t-1)+sp(1)*sp(2)*numel(fr)*(iter-1)) = 1.0;
    end
end
Iaux(isnan(Iaux))=0;
Iaux = permute(Iaux,[1 2 4 3]);
Ievol=[];
for i = 1:numel(fr)
    Ievol = [Ievol Iaux(:,:,:,i)];
end
padeo = ceil([sp(1) numel(fr)*sp(2)]/8)*8-[sp(1) numel(fr)*sp(2)];
M = sec2movie(padarray(Ievol,padeo,0,'pre'));
%movie(M,20);
movie2avi(M,'evol_javi.avi');