function m = A_L2(m, mat_size, SAMP_MASK, SENSITIVITY_MAPS)
%	Copyright (C) 2015 Javier Royuela del Val <jroyval@lpi.tel.uva.es>
%	Laboratorio de Procesado de Imagen, Universidad de Valladolid
%	www.lpi.tel.uva.es
%
%   When indicated, some parts are based on code from Salman Asif:
%       http://users.ece.gatech.edu/sasif/dynamicMRI/index.html
%
%   This program is free software: you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation, either version 3 of the License, or
%   (at your option) any later version.
%
%   This program is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
%
%   You should have received a copy of the GNU General Public License
%   along with this program.  If not, see <http://www.gnu.org/licenses/>.


% In y rows from different frames are concatenated along first dimension,
% since each frame can contain a different number of acquired rows.
% N = [0 cumsum(Nrows in each frame)];

% Leave data in ROWS x FRAMES x COLS x COILS order

sqrtROW = sqrt(mat_size(1));

if mat_size(4) > 1
    m = permute(...
          fft(...
            bsxfun(@times,reshape(m, mat_size(1:3)),SENSITIVITY_MAPS),...
          [],1),...
        [1 3 2 4]);
else
    m = permute(fft(reshape(m,mat_size(1:3)),[],1),[1 3 2 4]);
end

m=col(m(repmat(SAMP_MASK>0, [1 1 mat_size(2) mat_size(4)])))/sqrtROW;