function m = At_L2(y, mat_size, SAMP_MASK, SENSITIVITY_MAPS)
%	Copyright (C) 2015 Javier Royuela del Val <jroyval@lpi.tel.uva.es>
%	Laboratorio de Procesado de Imagen, Universidad de Valladolid
%	www.lpi.tel.uva.es
%
%   When indicated, some parts are based on code from Salman Asif:
%       http://users.ece.gatech.edu/sasif/dynamicMRI/index.html
%
%   This program is free software: you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation, either version 3 of the License, or
%   (at your option) any later version.
%
%   This program is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
%
%   You should have received a copy of the GNU General Public License
%   along with this program.  If not, see <http://www.gnu.org/licenses/>.

sqrtROW = sqrt(mat_size(1));

y_c = zeros(mat_size([1 3 2 4])); % ROWS x FRAMES x COLS x COILS
y_c(repmat(SAMP_MASK, [1 1 mat_size(2) mat_size(4)])) = y * sqrtROW;
y_c = permute(y_c,[1 3 2 4]);

if mat_size(4)>1
    m = col(sum(...
          bsxfun(@times,ifft(y_c,[],1),conj(SENSITIVITY_MAPS)),...
        4));
else
    m = col(ifft(y_c,[],1));
end