function I0 = javi_linear_adjoint(I1,hor_ind, ver_ind, ROW, COL)
%	Copyright (C) 2015 Javier Royuela del Val <jroyval@lpi.tel.uva.es>
%	Laboratorio de Procesado de Imagen, Universidad de Valladolid
%	www.lpi.tel.uva.es
%
%   When indicated, some parts are based on code from Salman Asif:
%       http://users.ece.gatech.edu/sasif/dynamicMRI/index.html
%
%   This program is free software: you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation, either version 3 of the License, or
%   (at your option) any later version.
%
%   This program is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
%
%   You should have received a copy of the GNU General Public License
%   along with this program.  If not, see <http://www.gnu.org/licenses/>.


ver_floor = max(1,min(floor(ver_ind(:)),ROW-1));
hor_floor = max(1,min(floor(hor_ind(:)),COL-1));
int_ind = gather(ver_floor + ROW * (hor_floor - 1)); % top left corner

Whh = hor_ind(:) - hor_floor;
Wvv = ver_ind(:) - ver_floor;

% I0 = zeros(ROW*COL,1);
% for i = 1:2
%     for j = 1:2
%         I0 = I0 + accumarray(int_ind + ((i-1) + ROW * (j-1)), ...
%             I1(:) .* ((2*i-3)*Wvv+2-i) .* ((2*j-3)*Whh+2-j), [ROW*COL, 1]);
%     end
% end

I0 = accumarray(int_ind      , I1(:) .* (1-Whh) .* (1-Wvv),[ROW*COL,1]) + ...
     accumarray(int_ind+1    , I1(:) .* (1-Whh) .* Wvv,    [ROW*COL,1]) + ...
     accumarray(int_ind+ROW  , I1(:) .* Whh .* (1-Wvv),    [ROW*COL,1]) + ...
     accumarray(int_ind+ROW+1, I1(:) .* Whh .* Wvv,        [ROW*COL,1]);
     

I0 = reshape(I0,ROW,COL);

end

