function sec2video(filename, I, fps)
%sec2video Write stack of images in I to avi file
%
%	Copyright (C) 2015 Javier Royuela del Val <jroyval@lpi.tel.uva.es>
%	Laboratorio de Procesado de Imagen, Universidad de Valladolid
%	www.lpi.tel.uva.es
%
%   When indicated, some parts are based on code from Salman Asif:
%       http://users.ece.gatech.edu/sasif/dynamicMRI/index.html
%
%   This program is free software: you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation, either version 3 of the License, or
%   (at your option) any later version.
%
%   This program is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
%
%   You should have received a copy of the GNU General Public License
%   along with this program.  If not, see <http://www.gnu.org/licenses/>.

I = abs(I)./max(abs(I(:)));

if ndims(I) == 3
    I = permute(I,[1 2 4 3]);
end
    
if size(I,3) == 1
%     vObj = VideoWriter(filename, 'Grayscale AVI');
%     I = abs(I)./max(abs(I(:)));
% elseif size(I,3) == 3
    vObj = VideoWriter(filename);
    vObj.Quality = 90;
else
    msgstr = ['For Grayscale videos, Img must be an array of size \n'...
              '[ROW, COL, FRAMES] or [ROW, COL, 1, FRAMES].\n'...
              'For RGB color videos, Img must be an array of size [ROW,COL,3,FRAMES].'];
          
    error(msgstr);
end

if nargin < 3, fps = size(I,4); end

vObj.FrameRate = fps;

vObj.open();
vObj.writeVideo(I);
vObj.close();

end

